//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TurboDBViewFrm.h"
#include "TDBViewExportFrm.h"
#include <assert.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TdbBatchMove"
#pragma link "TdbDataSet"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Open1Click(TObject *Sender)
{
  if(OpenDialog1->Execute()) {
    Close1Click(this);
    TdbTable1->DatabaseName = ExtractFilePath(OpenDialog1->FileName);
    TdbTable1->TableName = ExtractFileName(OpenDialog1->FileName);
    TdbTable1->Active = true;
    IndexComboBox->Items->Add("");
    for(int i = 0; i < TdbTable1->IndexDefs->Count; ++i) {
      IndexComboBox->Items->Add(TdbTable1->IndexDefs->Items[i]->Name);
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Close1Click(TObject *Sender)
{
  TdbTable1->Active = false;
  TdbTable1->IndexName = "";
  TdbTable1->Filtered = false;
  TdbTable1->Filter = "";
  IndexComboBox->Clear();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::IndexComboBoxChange(TObject *Sender)
{
  TdbTable1->IndexName = IndexComboBox->Items->Strings[IndexComboBox->ItemIndex];   
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Filter1Click(TObject *Sender)
{
  AnsiString AFilter;
  AFilter = TdbTable1->Filter;
  if (InputQuery("Filter", "Enter filter condition", AFilter)) {
    TdbTable1->Filtered = false;
    TdbTable1->Filter = AFilter;
    TdbTable1->Filtered = true;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
  Close();  
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Export1Click(TObject *Sender)
{
  if (Form2->ShowModal() == mrOk) {
    TdbBatchMove1->TdbTable = TdbTable1;
    TdbBatchMove1->FileName = Form2->ExportFileNameEdit->Text;
    switch (Form2->ExportFileFormatRadioGroup->ItemIndex) {
      case 0: TdbBatchMove1->FileType = tfTDB; break;
      case 1: TdbBatchMove1->FileType = tfCSV; break;
      case 2: TdbBatchMove1->FileType = tfXML; break;
      default: assert(false);
    }
    TdbBatchMove1->Filter = Form2->ExportFilterEdit->Text;
    TdbBatchMove1->Direction = bmdExport;
    TdbBatchMove1->Execute();
    TVarRec Args = {TdbBatchMove1->AppendedCount};
    ShowMessage(Format("%d records have been exported.", &Args, 0));
  }
}
//---------------------------------------------------------------------------

